#! /usr/bin/perl
#Name: rover-client-commands.perl
#Project: Rover control
#Homepage: www.RoboSpatium.de
#Author Norbert Heinz
#Version: 1.0
#Creation date: 16.12.2011
#Copyright: (c) 2011 by Norbert Heinz
#This program is free software you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation version 3 of the License.
#This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#You should have received a copy of the GNU General Public License along with this program if not, see http://www.gnu.org/licenses/.
#
#Client script for lander-client-commands.perl (located at the harddisk of the lander computer). Both scripts are used to send commands to the lander module of the RoboSpatium.

use strict;
use IO::Socket;

$|=1 ;

my $socket;
my $send_data = "";
my @file_info;
my $char_temp = "";
my ($seconds, $minutes, $hours, $day_of_month, $month, $year, $weekday, $day_of_year, $summertime) = localtime(time);

system("./KillRoverClientCommands.sh&");  #Script kills rover-client-commands.perl after 10 seconds if communication to Lander hangs.

$socket = new IO::Socket::INET (
                                  PeerAddr  => '192.168.1.xxx', # Type the IP adress of the Lander here
                                  PeerPort  =>  1099,           #Type the port of 'lander-client-commands.perl' here
                                  Proto => 'tcp',
                               )
or die "Couldn't connect to Server\n";

#Password must be identically at Lander script (lander-client-commands.perl).
$send_data = substr("TypeYourPasswordHere" . "                                 ", 0, 33);
$socket->send($send_data, 33);

$send_data = substr("LanderCommand=" . $ARGV[0] . "                              ", 0, 20);
print "Sending >" . $send_data . "<\n";
$socket->send($send_data, 20);
&LogFile($send_data);
sleep 2;

close $socket;

#++++++++++++++++++++++++ LogFile ++++++++++++++++++++++++++++++++++++++++++++++++++++++
sub LogFile{

  @file_info=stat("rover-client-commands.log");

  ($seconds, $minutes, $hours, $day_of_month, $month, $year, $weekday, $day_of_year, $summertime) = localtime(time());

  if ($hours < 10){
    $hours = "0" . $hours;
  }
  if ($minutes < 10){
    $minutes = "0" . $minutes;
  }
  if ($seconds < 10){
    $seconds = "0" . $seconds;
  }
  $month += 1;
  $year += 1900;

  if ($month < 10){
    $month = "0" . $month;
  }
  if ($day_of_month < 10){
    $day_of_month = "0" . $day_of_month;
  }

  $char_temp=substr($day_of_month . "." . $month . "." . $year . "-" . $hours . ":" . $minutes . ":" . $seconds . "                    ", 0, 20);


  if ($file_info[7] > 1000000){
    `mv rover-client-commands.log rover-client-commands01.log`
  }

  open(LOGFILE, ">> rover-client-commands.log") || die "Can not open file 'rover-client-commands.log'!\n";
    print LOGFILE $char_temp . $_[0] . "\n";
  close(LOGFILE);

}

