#! /usr/bin/perl
#Name: rover-status.pl
#Project: Rover control
#Homepage: www.HomoFaciens.de
#Author Norbert Heinz
#Version: 2.0
#Creation date: 05.06.2011
#Update to v2.0: 03.01.2012
#Copyright: (c) 2011 by Norbert Heinz
#This program is free software you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation version 3 of the License.
#This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#You should have received a copy of the GNU General Public License along with this program if not, see http://www.gnu.org/licenses/.
#
#Server script displays the status of the rover. Script is called by Javascript from control panel of the webpage

use strict;

my $numArgs = $#ARGV + 1;
my $argument_user = "";
my $argument_id = "";
my $argument_command = "";
my $argument_ip = "";
my $user = "";
my $UserID = "";
my $UserIP = "";
my $file_access = "roveraccess.txt";
my $file_server_status = "rover-connect.txt";
my $file_server_service = "service.txt";
my $in_line = "";
my $type_style =  '; font-family:serif,Times,serif; font-size:15px; color:#000000"';
my $user_is_ok = 0;
my $temp_char = "";
my $i = 0;
my $allowed_chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890_";
my $access_time = 0;
my $first_access_time = 0;
my @file_info;
my $file_size = 0;
my $file_out = "rovercommand.txt";
my $id = "";
my $ipAddress = "";
my ($seconds, $minutes, $hours, $day_of_month, $month, $year, $weekday, $day_of_year, $summertime) = localtime(time);
my $CTIME_String = localtime(time);


print "Content-type: text/html\n\n";
print '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN">' . "\n";
print "<html><head><title>Test-Ausgabe</title>" . "\n";

print "</head><body>";
print '<table border="0" cellpadding="0" cellspacing="0"><tr>' . "\n";


  if($numArgs < 1){#Script has to be called with at least 1 Argument
    print '<td style="background-color:#FF0000' . $type_style . '>Not enough parameters given!"</td>';
  }
  else{
    if(-e $file_server_service){#Rover is down for maintenance work
      if($ARGV[0] eq "ge"){
        print '<td style="background-color:#FF0000' . $type_style . '>Rover wird zur Zeit gewartet - Bitte warten."</td>';
        open(DATEIIN, '<'.$file_server_service) || die '<td style="background-color:#FF0000' . $type_style . '>File ' .  $file_server_service . ' not found?!?</td></tr></table></body></html>';
          $in_line = <DATEIIN>;          #first line displays reason in German language
        close (DATEIIN);
      }
      else{
        print '<td style="background-color:#FF0000' . $type_style . '>Rover service in progress - Please wait."</td>';
        open(DATEIIN, '<'.$file_server_service) || die '<td style="background-color:#FF0000' . $type_style . '>File ' .  $file_server_service . ' not found?!?</td></tr></table></body></html>';
          $in_line = <DATEIIN>;
          $in_line = <DATEIIN>;          #second line displays reason in English language
        close (DATEIIN);
      }
      print '</tr><tr><td style="background-color:#FF0000' . $type_style . '">' . $in_line . '</td>';

      print "</tr></table></body></html>" . "\n";
      exit (0);
    }
    if(-e $file_server_status){#Connection rover-server cut
      if($ARGV[0] eq "ge"){
        print '<td style="background-color:#FF0000' . $type_style . '>Verbindung zum Rover unterbrochen. Verbindungsaufbau in Bearbeitung."</td>';
      }
      else{
        print '<td style="background-color:#FF0000' . $type_style . '>Rover currently not connected. Reconnection in progress."</td>';
      }
    }
    else{
      if($numArgs == 4){#Call with language, Username, UserID and rover command
        $argument_user = $ARGV[1];
        $argument_user .= ( "                    ");
        $argument_user = substr($argument_user, 0, 20);

        $temp_char=$argument_user;
        $temp_char =~ s/^ +//;
        $temp_char =~ s/ +$//;
        for($i = 0; $i < length($temp_char); $i++){
          if(index($allowed_chars, substr($temp_char, $i, 1)) < 0) {
            if($ARGV[0] eq "ge"){
              print '<td style="background-color:#00FF00' . $type_style . '>Nicht erlaubtes Zeichen im Benutzernamen!!</td></tr></table><</body></html>';
            }
            else{
              print '<td style="background-color:#00FF00' . $type_style . '>Not allowed character in username!</td></tr></table><</body></html>';
            }
            die;
          }
        }

        $argument_id = $ARGV[2];
        $argument_id .= ( "                    ");
        $argument_id = substr($argument_id, 0, 20);
        $argument_command = $ARGV[3];
        $argument_command .= ( "                    ");
        $argument_command = substr($argument_command, 0, 20);
        $argument_ip = $ENV{'REMOTE_ADDR'};
        $argument_ip = substr($argument_ip, 0, rindex($argument_ip, ".")) . ".xxx";
        $argument_ip .= ("                    ");
        $argument_ip = substr($argument_ip, 0, 20);
        $access_time = time() . "                    ";
        $access_time = substr($access_time, 0, 20);

        @file_info=stat($file_access);
        $file_size = $file_info[7];

        if ($file_size < 1000){
          open(DATEIOUT,'>>'.$file_access) || die '<td style="background-color:#FF0000' . $type_style . '>Can not open file' .  $file_access . '. Please try again.</td></tr></table></body></html>';
            print DATEIOUT $argument_user . $argument_id . $argument_ip . $access_time . "_\n";
          close (DATEIOUT);
        }

        #Compare command line arguments with those iside of the first line in file roveraccess.txt
        open(DATEIIN, '<'.$file_access) || die '<td style="background-color:#FF0000' . $type_style . '>File ' .  $file_out . ' not found, please try again.</td></tr></table></body></html>';
          $in_line = <DATEIIN>;
        close (DATEIIN);

        $user = substr($in_line, 0, 20);
        $id = substr($in_line, 20, 20);
        $ipAddress = substr($in_line, 40, 20);
        $first_access_time = substr($in_line, 60, 20);

        if ($argument_user eq $user and $argument_id eq $id){#User and ID from commandline equals those at the first line of roveraccess.txt
          $user_is_ok = 1;
          if($ARGV[0] eq "ge"){
            print '<td style="background-color:#00FF00' . $type_style . '>Rover steht unter deinem Kommando: "' . $user . '" from "' . $UserIP . '"</td>';
          }
          else{
            print '<td style="background-color:#00FF00' . $type_style . '>Rover is under your control: "' . $user . '" from "' . $UserIP . '"</td>';
          }
          if(-e $file_out){
            if($ARGV[0] eq "ge"){
              print '</tr><tr><td style="background-color:#FF0000' . $type_style . '>Kommandopipeline noch nicht frei. Versuch es in 5 Sekunden nochmal.</td>';
            }
            else{
              print '</tr><tr><td style="background-color:#FF0000' . $type_style . '>Command pipe not free for new command. Please try again in five seconds.</td>';
            }
          }
          else{
            open(DATEIOUT,'>'.$file_out) || die '<td style="background-color:#FF0000' . $type_style . '>Can not open command file' .  $file_out . '. Please try again.</td></tr></table></body></html>';
              print DATEIOUT $argument_command . $first_access_time . $ipAddress . $user . "_\n";
            close (DATEIOUT);
            &AccessLogFile($argument_command . $ipAddress . $user . substr(time() . "                    ", 0, 20)) . "_en";
            $argument_command =~ s/^ +//;
            $argument_command =~ s/ +$//;
            if($ARGV[0] eq "ge"){
              print '</tr><tr><td style="background-color:#FFFFFF' . $type_style . '>' . $argument_command . ' an Rover &uuml;bermittlet.</td>';
            }
            else{
              print '</tr><tr><td style="background-color:#FFFFFF' . $type_style . '>' . $argument_command . ' sent to rover</td>';
            }
          }
        }#if ($argument_user eq $user and $argument_id eq $id)
        else{
          $user_is_ok = 2;
          if($ARGV[0] eq "ge"){
            print '<td style="background-color:#FF0000' . $type_style . '>Rover wird zur Zeit gesteuert von: "' . $user . '" from "' . $UserIP . '"</td>';
          }
          else{
            print '<td style="background-color:#FF0000' . $type_style . '>Rover currently in use by: "' . $user . '" from "' . $UserIP . '"</td>';
          }
          $user =~ s/^ +//;
          $user =~ s/ +$//;
          $ipAddress =~ s/^ +//;
          $ipAddress =~ s/ +$//;
          if($ARGV[0] eq "ge"){
            print '</tr><tr><td style="background-color:#FF0000' . $type_style . '>Warte bitte, bis der Rover freigegeben wird! In 5-Minuten-Intervallen erfolgt die Freigabe.</td>';
          }
          else{
            print '</tr><tr><td style="background-color:#FF0000' . $type_style . '>Please wait until rover is free! After 5min the control is released.</td>';
          }
        }#if ($argument_user eq $user and $argument_id eq $id) - else construct
      }#if($numArgs == 4){


      if($numArgs  > 2){#Call without transmitted command (fourth argument). Display status.
        if($user_is_ok == 0){
          open(DATEIIN, '<'.$file_access) || die '<td style="background-color:#FFFFFF' . $type_style . '>File ' .  $file_access . ' not found, please try again.</td></tr></table></body></html>';
            $in_line = <DATEIIN>;
          close (DATEIIN);

          if($in_line eq ""){
            if($ARGV[0] eq "ge"){
              print '<td style="background-color:#FFFF00' . $type_style . '>Rover steht zur Verf&uuml;gung. Klick "Befehl senden", um die Kontrolle zu &uuml;bernehmen...</td>' . "\n";
            }
            else{
              print '<td style="background-color:#FFFF00' . $type_style . '>Rover free for use. Press "Send command" to take control...</td>' . "\n";
            }
          }
          else{
            $user = substr($in_line, 0, 20);
            $UserID = substr($in_line, 20, 20);
            $UserIP = substr($in_line, 40, 20);
            $user =~ s/^ +//;
            $user =~ s/ +$//;
            $UserID =~ s/^ +//;
            $UserID =~ s/ +$//;
            $UserIP =~ s/^ +//;
            $UserIP =~ s/ +$//;
            $UserIP = substr($UserIP, 0, rindex($UserIP, ".")) . ".xxx";
            $argument_user = $ARGV[1];
            $argument_id = $ARGV[2];

            if($UserID eq $argument_id && $user eq $argument_user){
              if($ARGV[0] eq "ge"){
                print '<td style="background-color:#00FF00' . $type_style . '>Rover steht unter deinem Kommando: "' . $user . '" von "' . $UserIP . '"</td>' . "\n";
              }
              else{
                print '<td style="background-color:#00FF00' . $type_style . '>Rover is under your control: "' . $user . '" from "' . $UserIP . '"</td>' . "\n";
              }
            }
            else{
              if($ARGV[0] eq "ge"){
                print '<td style="background-color:#FF0000' . $type_style . '>Rover steht unter dem Kommando von: "' . $user . '" mit der Adresse "' . $UserIP . '"</td>' . "\n";
              }
              else{
                print '<td style="background-color:#FF0000' . $type_style . '>Rover currently in use by: "' . $user . '" from "' . $UserIP . '"</td>' . "\n";
              }
            }
            if (-e "rovercommand.txt"){
              if($ARGV[0] eq "ge"){
                print '</tr><tr><td style="background-color:#FFFFFF' . $type_style . '>Verarbeite aktuellen Befehl - bitte warten (normalerweise 10 bis 30Sekunden bis zum neuen Bild).</td>' . "\n";
              }
              else{
                print '</tr><tr><td style="background-color:#FFFFFF' . $type_style . '>Processing current command - please wait (usually 10 to 30 seconds) for new pic.</td>' . "\n";
              }
            }
            else{
              if($ARGV[0] eq "ge"){
                print '</tr><tr><td style="background-color:#FFFF00' . $type_style . '>Hallo Kontrollstation auf dem Planeten Erde, klick "Befehl senden", um den Befehlssatz zu starten!</td>' . "\n";
              }
              else{
                print '</tr><tr><td style="background-color:#FFFF00' . $type_style . '>Hello control station on planet Earth, press "send command" to transmit instruction set!</td>' . "\n";
              }
            }
          }
        }#if($user_is_ok == 0)
      }#if($numArgs  > 2){
    }#if(-e $file_server_status) - else construction
  }#if($numArgs < 1){


  if($ARGV[0] eq "ge"){
    open(DATEIIN, '<IrModule.txt') || die '<td style="background-color:#FFFFFF' . $type_style . '>File IrModule.txt not found, please try again.</td></tr></table></body></html>';
      $in_line = <DATEIIN>;  #First 3 lines English text
      $in_line = <DATEIIN>;  #First 3 lines English text
      $in_line = <DATEIIN>;  #First 3 lines English text
      $in_line = <DATEIIN>;  #Next 3 lines German text
      print '</tr><tr><td style="background-color:#FFFFFF' . $type_style . '>' . $in_line . '</td>' . "\n";
      $in_line = <DATEIIN>;  #Next 3 lines German text
      print '</tr><tr><td style="background-color:#FFFFFF' . $type_style . '>' . $in_line . '</td>' . "\n";
      $in_line = <DATEIIN>;  #Next 3 lines German text
      print '</tr><tr><td style="background-color:#FFFFFF' . $type_style . '>' . $in_line . '</td>' . "\n";
    close (DATEIIN);
  }
  else{
    open(DATEIIN, '<IrModule.txt') || die '<td style="background-color:#FFFFFF' . $type_style . '>File IrModule.txt not found, please try again.</td></tr></table></body></html>';
      $in_line = <DATEIIN>;
      print '</tr><tr><td style="background-color:#FFFFFF' . $type_style . '>' . $in_line . '</td>' . "\n";
      $in_line = <DATEIIN>;
      print '</tr><tr><td style="background-color:#FFFFFF' . $type_style . '>' . $in_line . '</td>' . "\n";
      $in_line = <DATEIIN>;
      print '</tr><tr><td style="background-color:#FFFFFF' . $type_style . '>' . $in_line . '</td>' . "\n";
    close (DATEIIN);
  }


print "</tr></table></body></html>" . "\n";

exit (0);


#+++++++++++++++++++++++++ AccessFile ++++++++++++++++++++++++++++++++++++++++++++++++++
sub AccessLogFile{#Write all received commands in logfile

  @file_info=stat("rover-access.log");

  if ($file_info[7] > 10000000){
    `mv rover-access.log rover-access01.log`
  }

  ($seconds, $minutes, $hours, $day_of_month, $month, $year, $weekday, $day_of_year, $summertime) = localtime(time());

  if ($hours < 10){
    $hours = "0" . $hours;
  }
  if ($minutes < 10){
    $minutes = "0" . $minutes;
  }
  if ($seconds < 10){
    $seconds = "0" . $seconds;
  }
  $month += 1;
  $year += 1900;

  if ($month < 10){
    $month = "0" . $month;
  }
  if ($day_of_month < 10){
    $day_of_month = "0" . $day_of_month;
  }

  open(LOGFILE, ">> rover-access.log") || die '<td style="background-color:#FF0000' . $type_style . '>Can not open file "rover-access.log"!</td></tr></table></body></html>';
    print LOGFILE $_[0] . $day_of_month . "." . $month . "." . $year . " - " . $hours . ":" . $minutes . ":" . $seconds . "\n";
  close(LOGFILE);

}
